## pemmican 1.0.3

=== Makefile ===
# vim: set noet sw=4 ts=4 fileencoding=utf-8:

# External utilities
PYTHON=python3
PIP=pip
PYTEST=pytest
TWINE=twine
PYFLAGS=
MSGINIT=msginit
MSGMERGE=msgmerge
MSGFMT=msgfmt
XGETTEXT=xgettext
DEST_DIR=/

# Find the location of the GObject introspection libs and cairo (required for
# the develop target)
GI:=$(wildcard /usr/lib/python3/dist-packages/gi)
GOBJECT:=
GLIB:=

# Calculate the base names of the distribution, the location of all source,
# documentation, packaging, icon, and executable script files
NAME:=$(shell $(PYTHON) $(PYFLAGS) setup.py --name)
WHEEL_NAME:=$(subst -,_,$(NAME))
VER:=$(shell $(PYTHON) $(PYFLAGS) setup.py --version)
PY_SOURCES:=$(shell \
	$(PYTHON) $(PYFLAGS) setup.py egg_info >/dev/null 2>&1 && \
	cat $(WHEEL_NAME).egg-info/SOURCES.txt | grep -v "\.egg-info"  | grep -v "\.mo$$")
DOC_SOURCES:=docs/conf.py \
	$(wildcard docs/*.png) \
	$(wildcard docs/*.svg) \
	$(wildcard docs/*.dot) \
	$(wildcard docs/*.mscgen) \
	$(wildcard docs/*.gpi) \
	$(wildcard docs/*.rst) \
	$(wildcard docs/*.pdf)
SUBDIRS:=

# Calculate the name of all outputs
DIST_WHEEL=dist/$(WHEEL_NAME)-$(VER)-py3-none-any.whl
DIST_TAR=dist/$(NAME)-$(VER).tar.gz
DIST_ZIP=dist/$(NAME)-$(VER).zip
POT_FILE=po/$(NAME).pot
PO_FILES:=$(wildcard po/*.po)
MO_FILES:=$(patsubst po/%.po,po/mo/%/LC_MESSAGES/$(NAME).mo,$(PO_FILES))
MAN_PAGES=\
	man/pemmican-cli.1 \
	man/pemmican-mon.1 \
	man/pemmican-reset.1


# Default target
all:
	@echo "make install - Install on local system"
	@echo "make develop - Install symlinks for development"
	@echo "make pot - Update translation template and sources"
	@echo "make mo - Generate translation files"
	@echo "make test - Run tests"
	@echo "make doc - Generate HTML and PDF documentation"
	@echo "make source - Create source package"
	@echo "make wheel - Generate a PyPI wheel package"
	@echo "make zip - Generate a source zip package"
	@echo "make tar - Generate a source tar package"
	@echo "make dist - Generate all packages"
	@echo "make clean - Get rid of all generated files"
	@echo "make release - Create and tag a new release"
	@echo "make upload - Upload the new release to repositories"

install: $(SUBDIRS)
	$(PYTHON) $(PYFLAGS) setup.py install --root $(DEST_DIR)

doc: $(DOC_SOURCES)
	$(MAKE) -C docs clean
	$(MAKE) -C docs html
	$(MAKE) -C docs epub
	$(MAKE) -C docs latexpdf
	$(MAKE) $(MAN_PAGES)

preview:
	$(MAKE) -C docs preview

source: $(DIST_TAR) $(DIST_ZIP)

wheel: $(DIST_WHEEL)

zip: $(DIST_ZIP)

tar: $(DIST_TAR)

dist: $(DIST_WHEEL) $(DIST_TAR) $(DIST_ZIP)

pot: $(POT_FILE) $(PO_FILES)

mo: $(MO_FILES)

develop:
	@# These have to be done separately to avoid a cockup...
	$(PIP) install -U setuptools
	$(PIP) install -U pip
	$(PIP) install -U twine
	$(PIP) install -U tox
	$(PIP) install -e .[gui,doc,test]
	@# If we're in a venv, link the system's GObject Introspection (gi) into it
ifeq ($(VIRTUAL_ENV),)
	@echo "Virtualenv not detected! You may need to link gi manually"
else
ifeq ($(GI),)
	@echo "ERROR: gi not found. Install the python{,3}-gi packages"
else
	ln -sf $(GI) $(VIRTUAL_ENV)/lib/python*/site-packages/
endif
ifneq ($(GLIB),)
	ln -sf $(GLIB) $(VIRTUAL_ENV)/lib/python*/site-packages/
endif
ifneq ($(GOBJECT),)
	ln -sf $(GOBJECT) $(VIRTUAL_ENV)/lib/python*/site-packages/
endif
endif

test:
	$(PYTEST)

clean:
	rm -fr dist/ build/ man/ .pytest_cache/ .mypy_cache/ $(WHEEL_NAME).egg-info/ tags .coverage
	for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir clean; \
	done
	find $(CURDIR) -name "*.pyc" -delete
	find $(CURDIR) -name "__pycache__" -delete

tags: $(PY_SOURCES)
	ctags -R --exclude="build/*" --exclude="docs/*" --languages="Python"

lint: $(PY_SOURCES)
	pylint $(WHEEL_NAME)

$(SUBDIRS):
	$(MAKE) -C $@

$(MAN_PAGES): $(DOC_SOURCES)
	$(MAKE) -C docs man
	mkdir -p man/
	cp build/man/*.[0-9] man/

$(POT_FILE): $(PY_SOURCES)
	$(XGETTEXT) -o $@ $(filter %.py,$^) $(filter %.ui,$^)

po/%.po: $(POT_FILE)
	$(MSGMERGE) -U $@ $<

po/mo/%/LC_MESSAGES/$(NAME).mo: po/%.po
	mkdir -p $(dir $@)
	$(MSGFMT) $< -o $@

$(DIST_TAR): $(PY_SOURCES) $(SUBDIRS)
	$(PYTHON) $(PYFLAGS) setup.py sdist --formats gztar

$(DIST_ZIP): $(PY_SOURCES) $(SUBDIRS)
	$(PYTHON) $(PYFLAGS) setup.py sdist --formats zip

$(DIST_WHEEL): $(PY_SOURCES) $(SUBDIRS)
	$(PYTHON) $(PYFLAGS) setup.py bdist_wheel

release:
	$(MAKE) clean
	test -z "$(shell git status --porcelain)"
	git tag -s v$(VER) -m "Release $(VER)"
	git push origin v$(VER)

upload: $(DIST_TAR) $(DIST_WHEEL)
	$(TWINE) check $(DIST_TAR) $(DIST_WHEEL)
	$(TWINE) upload $(DIST_TAR) $(DIST_WHEEL)

.PHONY: all install develop test doc source wheel zip tar dist clean tags release upload $(SUBDIRS)

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = ../build
PY_SOURCES    := $(wildcard ../pemmican/*.py)
DOT_DIAGRAMS  := $(wildcard images/*.dot images/*/*.dot)
MSC_DIAGRAMS  := $(wildcard images/*.mscgen images/*/*.mscgen)
GPI_DIAGRAMS  := $(wildcard images/*.gpi images/*/*.gpi)
SVG_IMAGES    := $(wildcard images/*.svg images/*/*.svg) $(DOT_DIAGRAMS:%.dot=%.svg) $(MSC_DIAGRAMS:%.mscgen=%.svg)
PNG_IMAGES    := $(wildcard images/*.png images/*/*.png) $(GPI_DIAGRAMS:%.gpi=%.png) $(SVG_IMAGES:%.svg=%.png)
PDF_IMAGES    := $(SVG_IMAGES:%.svg=%.pdf) $(GPI_DIAGRAMS:%.gpi=%.pdf) $(DOT_DIAGRAMS:%.dot=%.pdf) $(MSC_DIAGRAMS:%.mscgen=%.pdf)
INKSCAPE_VER  := $(shell inkscape --version | sed -ne '/^Inkscape/ s/^Inkscape \([0-9]\+\)\..*$$/\1/p')

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  preview    to start a web-server that watches for file changes"
	@echo "             and re-builds the docs when required"
	@echo "  json       to make JSON files"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html: $(SVG_IMAGES) $(PNG_IMAGES)
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex: $(PDF_IMAGES)
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf: $(PDF_IMAGES)
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

preview:
	../scripts/previewer $(BUILDDIR)/html

%.svg: %.mscgen
	mscgen -T svg -o $@ $<

%.svg: %.dot
	dot -T svg -o $@ $<

%.png: %.gpi
	gnuplot -e "set term pngcairo transparent size 400,400" $< > $@

ifeq ($(INKSCAPE_VER),0)
%.png: %.svg
	inkscape --export-dpi 150 -e $@ $<

%.pdf: %.svg
	inkscape -A $@ $<
else
%.png: %.svg
	inkscape --export-dpi 150 --export-type png -o $@ $<

%.pdf: %.svg
	inkscape --export-type pdf -o $@ $<
endif

%.pdf: %.gpi
	gnuplot -e "set term pdfcairo size 5cm,5cm" $< > $@

%.pdf: %.mscgen
	mscgen -T eps -o - $< | ps2pdf -dEPSCrop - $@

.PHONY: help clean html preview json epub latex latexpdf text man changes linkcheck doctest gettext

=== debian/changelog ===
pemmican (1.0.3-0ubuntu2) questing; urgency=medium

  * d/p/lp2120731-fix-reset-launch.patch: Do not prevent applications from
    launching under GNOME when warning is displayed (LP: #2120731)
  * d/p/lp2124182-no-gdm-launch.patch: Do not launch daemons under GDM
    (LP: #2124182)

 -- Dave Jones <dave.jones@canonical.com>  Thu, 18 Sep 2025 12:26:27 +0100

pemmican (1.0.3-0ubuntu1) noble; urgency=medium

  * Fixed binary executed for pemmican-monitor.service (LP: #2056553)
  * Added all the bits necessary for translations

 -- Dave Jones <dave.jones@canonical.com>  Fri, 08 Mar 2024 13:31:29 +0000

pemmican (1.0.2-0ubuntu1) noble; urgency=medium

  * New upstream release; re-licenses under GPL3
  * d/watch: fix file regex

 -- Dave Jones <dave.jones@canonical.com>  Fri, 23 Feb 2024 16:06:18 +0000

pemmican (1.0.1-0ubuntu1) noble; urgency=medium

  * Initial release (LP: #2054344)

 -- Dave Jones <dave.jones@canonical.com>  Sun, 18 Feb 2024 21:32:10 +0000

=== debian/control ===
Source: pemmican
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Dave Jones <dave.jones@canonical.com>
Uploaders:
 Dave Jones <dave.jones@canonical.com>
Homepage: https://pemmican.readthedocs.io/
Section: python
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 python3-all,
 python3-setuptools,
 python3-doc,
 python3-gi,
 python3-pyudev,
 python3-dbus,
 python3-sphinx,
 python3-sphinx-rtd-theme,
 python3-pytest,
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/python-team/packages/pemmican.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/pemmican
Rules-Requires-Root: no

Package: pemmican-common
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Description: Notify users of Raspberry Pi 5 power issues
 pemmican is a trivial service which notifies users of issues reported by the
 Raspberry Pi 5 PMIC (Power Management IC). Specifically, reset due to
 undervolt, runtime undervolt, overcurrent in USB peripherals, and failure to
 negotiate a 5A supply are all reportable issues.
 .
 This is the package containing the Python implementation. You likely want
 to install either pemmican-server or pemmican-desktop to install the service
 definitions.

Package: pemmican-server
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
 pemmican-common,
Description: Notify users of Raspberry Pi 5 power issues via update-motd
 pemmican is a trivial service which notifies users of issues reported by the
 Raspberry Pi 5 PMIC (Power Management IC). Specifically, reset due to
 undervolt, runtime undervolt, overcurrent in USB peripherals, and failure to
 negotiate a 5A supply are all reportable issues.
 .
 This package installs the man:update-motd(5) hook to run man:pemmican-cli(1)
 on server installations.

Package: pemmican-desktop
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
 pemmican-common,
 python3-pyudev,
 python3-dbus,
 python3-gi,
Description: Notify users of Raspberry Pi 5 power issues via freedesktop notifications
 pemmican is a trivial service which notifies users of issues reported by the
 Raspberry Pi 5 PMIC (Power Management IC). Specifically, reset due to
 undervolt, runtime undervolt, overcurrent in USB peripherals, and failure to
 negotiate a 5A supply are all reportable issues.
 .
 This package installs the user services to launch man:pemmican-reset(1) and
 man:pemmican-mon(1) as part of the graphical session.

Package: pemmican-doc
Architecture: all
Section: doc
Depends: ${sphinxdoc:Depends}, ${misc:Depends}
Description: Documentation for the pemmican utility
 pemmican is a trivial service which notifies users of issues reported by the
 Raspberry Pi 5 PMIC (Power Management IC). Specifically, reset due to
 undervolt, runtime undervolt, overcurrent in USB peripherals, and failure to
 negotiate a 5A supply are all reportable issues.
 .
 This is the documentation package for pemmican.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1
export DH_OPTIONS

export PYBUILD_DESTDIR=debian/pemmican-common

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	python3 setup.py sdist
endif
	dh_auto_test

override_dh_auto_build:
	dh_auto_build
	# Update translations
	make mo
	# Build HTML docs (for -doc package), and manpages (for bin packages)
	PYTHONPATH=. sphinx-build -N -bhtml docs/ build/html
	PYTHONPATH=. sphinx-build -N -bman docs/ build/man

override_dh_auto_install:
	dh_auto_install
	# Move the binaries into their respective packages
	mkdir -p debian/pemmican-server/usr/bin
	mkdir -p debian/pemmican-desktop/usr/bin
	mv debian/pemmican-common/usr/bin/pemmican-cli debian/pemmican-server/usr/bin/
	mv debian/pemmican-common/usr/bin/pemmican-mon debian/pemmican-desktop/usr/bin/
	mv debian/pemmican-common/usr/bin/pemmican-reset debian/pemmican-desktop/usr/bin/

override_dh_installsystemduser:
	dh_installsystemduser -ppemmican-desktop pemmican-reset.service pemmican-monitor.service

override_dh_installdocs:
	dh_installdocs -ppemmican-doc --doc-main-package=pemmican-common
	dh_installdocs -ppemmican-common
	dh_installdocs -ppemmican-server
	dh_installdocs -ppemmican-desktop

=== debian/tests/control ===
Test-Command: pytest-3 -rsx --tb=short tests/
Depends: pemmican-common, python3-pytest, python3-gi, python3-pyudev, python3-dbus
